Make WordPress Core


Ignore:
Timestamp:
03/11/2025 02:17:41 PM (12 months ago)
Author:
TimothyBlynJacobs
Message:

REST API: Fix fatal error when making HEAD requests with _fields filter.

In [59889] the REST API controllers were adjusted to perform less work when responding to HEAD requests. The WP_REST_Response body would now be null, which caused issues with filters that expected the response body to be an array.

This commit sets the response body to be an empty array when preparing the response instead. The body will still be discarded, but this provides better backward comppatibility with code that assumes an array will be used.

See #56481.
Props antonvlasenko, timothyblynjacobs, mamaduka, wildworks.

File:
1 edited

Legend:

Unmodified
Added
Removed
  • trunk/tests/phpunit/tests/rest-api/rest-tags-controller.php

    r59899 r59970  
    16151615            return null;
    16161616        }
    1617         $this->assertNull( $response->get_data(), 'The server should not generate a body in response to a HEAD request.' );
     1617        $this->assertSame( array(), $response->get_data(), 'The server should not generate a body in response to a HEAD request.' );
     1618    }
     1619
     1620    /**
     1621     * @dataProvider data_head_request_with_specified_fields_returns_success_response
     1622     * @ticket 56481
     1623     *
     1624     * @param string $path The path to test.
     1625     */
     1626    public function test_head_request_with_specified_fields_returns_success_response( $path ) {
     1627        $tag_id  = self::factory()->tag->create();
     1628        $request = new WP_REST_Request( 'HEAD', sprintf( $path, $tag_id ) );
     1629        $request->set_param( '_fields', 'id' );
     1630        $server   = rest_get_server();
     1631        $response = $server->dispatch( $request );
     1632        add_filter( 'rest_post_dispatch', 'rest_filter_response_fields', 10, 3 );
     1633        $response = apply_filters( 'rest_post_dispatch', $response, $server, $request );
     1634        remove_filter( 'rest_post_dispatch', 'rest_filter_response_fields', 10 );
     1635
     1636        $this->assertSame( 200, $response->get_status(), 'The response status should be 200.' );
     1637    }
     1638
     1639    /**
     1640     * Data provider intended to provide paths for testing HEAD requests.
     1641     *
     1642     * @return array
     1643     */
     1644    public static function data_head_request_with_specified_fields_returns_success_response() {
     1645        return array(
     1646            'get_item request'  => array( '/wp/v2/tags/%d' ),
     1647            'get_items request' => array( '/wp/v2/tags' ),
     1648        );
    16181649    }
    16191650}
Note: See TracChangeset for help on using the changeset viewer.